#include <bits/stdc++.h>
//#define int long long

using namespace std;
const int INF = 1e9;

struct node {
    vector <int> cnt;

    node() {
        cnt.assign(2, 0);
    }
};

vector <node> t;

void build(vector <int> &a, int v, int tl, int tr) {
    if (tl + 1 == tr) {
        t[v].cnt[a[tl]]++;
        return;
    }

    int tm = (tl + tr) / 2;
    build(a, v * 2, tl, tm);
    build(a, v * 2 + 1, tm, tr);
    t[v].cnt[0] = t[v * 2].cnt[0] + t[v * 2 + 1].cnt[0];
    t[v].cnt[1] = t[v * 2].cnt[1] + t[v * 2 + 1].cnt[1];
}

void update(int v, int tl, int tr, int i, int x) {
    if (i < tl || i >= tr) {
        return;
    }
    if (tl + 1 == tr) {
        t[v].cnt.assign(2, 0);
        t[v].cnt[x]++;
        return;
    }

    int tm = (tl + tr) / 2;
    update(v * 2, tl, tm, i, x);
    update(v * 2 + 1, tm, tr, i, x);
    t[v].cnt[0] = t[v * 2].cnt[0] + t[v * 2 + 1].cnt[0];
    t[v].cnt[1] = t[v * 2].cnt[1] + t[v * 2 + 1].cnt[1];
}

int get(int v, int tl, int tr, int l, int r, int x) {
    if (r <= tl || l >= tr) {
        return 0;
    }

    if (l <= tl && tr <= r) {
        return t[v].cnt[x];
    }

    int tm = (tl + tr) / 2;
    return get(v * 2, tl, tm, l, r, x) + get(v * 2 + 1, tm, tr, l, r, x);
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, q;
    cin >> n >> q;

    vector <int> a(n);

    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        a[i]--;
    }
    t.resize(n * 4);
    build(a, 1, 0, n);

    while (q--) {
        int tt;
        cin >> tt;

        if (tt == 1) {
            int x;
            cin >> x;
            x--;

            int t1 = a[x + 1];
            int t2 = a[x];
            update(1, 0, n, x, t1);
            update(1, 0, n, x + 1, t2);
            swap(a[x], a[x + 1]);
        }
        else {
            int y;
            cin >> y;
            y--;

            int ans = 0;
            if (a[0] == a[y]) {
                int c = get(1, 0, n, 0, y, a[y]);
                ans = c + min(c, get(1, 0, n, 0, n, a[y] ^ 1)) + 1;
            }
            else {
                int c = get(1, 0, n, 0, y, a[y]);
                int p = get(1, 0, n, 0, n, a[y] ^ 1);
                ans = c + min(c + 1, p) + 1;
            }

            cout << ans << "\n";
        }
    }

    return 0;
}